diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/propagation/model/three-gpp-propagation-loss-model.cc ns-3.42/src/propagation/model/three-gpp-propagation-loss-model.cc
--- ns-3.41/src/propagation/model/three-gpp-propagation-loss-model.cc	2024-02-09 14:44:08.457794000 -0800
+++ ns-3.42/src/propagation/model/three-gpp-propagation-loss-model.cc	2024-05-29 15:29:47.160073800 -0700
@@ -22,6 +22,7 @@
 
 #include "ns3/boolean.h"
 #include "ns3/double.h"
+#include "ns3/geocentric-constant-position-mobility-model.h"
 #include "ns3/log.h"
 #include "ns3/mobility-model.h"
 #include "ns3/node.h"
@@ -30,14 +31,246 @@
 
 #include <cmath>
 
-namespace ns3
+namespace
+{
+/**
+ * The enumerator used for code clarity when performing parameter assignment in the GetLoss Methods
+ */
+enum SFCL_params
+{
+    S_LOS_sigF,
+    S_NLOS_sigF,
+    S_NLOS_CL,
+    Ka_LOS_sigF,
+    Ka_NLOS_sigF,
+    Ka_NLOS_CL,
+};
+
+/**
+ * The map containing the 3GPP value regarding Shadow Fading and Clutter Loss tables for the
+ * NTN Dense Urban scenario
+ */
+const std::map<int, std::vector<float>> SFCL_DenseUrban{
+    {10, {3.5, 15.5, 34.3, 2.9, 17.1, 44.3}},
+    {20, {3.4, 13.9, 30.9, 2.4, 17.1, 39.9}},
+    {30, {2.9, 12.4, 29.0, 2.7, 15.6, 37.5}},
+    {40, {3.0, 11.7, 27.7, 2.4, 14.6, 35.8}},
+    {50, {3.1, 10.6, 26.8, 2.4, 14.2, 34.6}},
+    {60, {2.7, 10.5, 26.2, 2.7, 12.6, 33.8}},
+    {70, {2.5, 10.1, 25.8, 2.6, 12.1, 33.3}},
+    {80, {2.3, 9.2, 25.5, 2.8, 12.3, 33.0}},
+    {90, {1.2, 9.2, 25.5, 0.6, 12.3, 32.9}},
+};
+
+/**
+ * The map containing the 3GPP value regarding Shadow Fading and Clutter Loss tables for the
+ * NTN Urban scenario
+ */
+const std::map<int, std::vector<float>> SFCL_Urban{
+    {10, {4, 6, 34.3, 4, 6, 44.3}},
+    {20, {4, 6, 30.9, 4, 6, 39.9}},
+    {30, {4, 6, 29.0, 4, 6, 37.5}},
+    {40, {4, 6, 27.7, 4, 6, 35.8}},
+    {50, {4, 6, 26.8, 4, 6, 34.6}},
+    {60, {4, 6, 26.2, 4, 6, 33.8}},
+    {70, {4, 6, 25.8, 4, 6, 33.3}},
+    {80, {4, 6, 25.5, 4, 6, 33.0}},
+    {90, {4, 6, 25.5, 4, 6, 32.9}},
+};
+
+/**
+ * The map containing the 3GPP value regarding Shadow Fading and Clutter Loss tables for the
+ * NTN Suburban and Rural scenarios
+ */
+const std::map<int, std::vector<float>> SFCL_SuburbanRural{
+    {10, {1.79, 8.93, 19.52, 1.9, 10.7, 29.5}},
+    {20, {1.14, 9.08, 18.17, 1.6, 10.0, 24.6}},
+    {30, {1.14, 8.78, 18.42, 1.9, 11.2, 21.9}},
+    {40, {0.92, 10.25, 18.28, 2.3, 11.6, 20.0}},
+    {50, {1.42, 10.56, 18.63, 2.7, 11.8, 18.7}},
+    {60, {1.56, 10.74, 17.68, 3.1, 10.8, 17.8}},
+    {70, {0.85, 10.17, 16.5, 3.0, 10.8, 17.2}},
+    {80, {0.72, 11.52, 16.3, 3.6, 10.8, 16.9}},
+    {90, {0.72, 11.52, 16.3, 0.4, 10.8, 16.8}},
+};
+
+/**
+ * Array containing the attenuation given by atmospheric absorption. 100 samples are selected for
+ * frequencies from 1GHz to 100GHz. In order to get the atmospheric absorption loss for a given
+ * frequency f: 1- round f to the closest integer between 0 and 100. 2- use the obtained integer to
+ * access the corresponding element in the array, that will give the attenuation at that frequency.
+ * Data is obtained form ITU-R P.676 Figure 6.
+ */
+const double atmosphericAbsorption[101] = {
+    0,        0.0300,   0.0350,  0.0380,  0.0390,  0.0410,  0.0420,  0.0450,  0.0480,   0.0500,
+    0.0530,   0.0587,   0.0674,  0.0789,  0.0935,  0.1113,  0.1322,  0.1565,  0.1841,   0.2153,
+    0.2500,   0.3362,   0.4581,  0.5200,  0.5200,  0.5000,  0.4500,  0.3850,  0.3200,   0.2700,
+    0.2500,   0.2517,   0.2568,  0.2651,  0.2765,  0.2907,  0.3077,  0.3273,  0.3493,   0.3736,
+    0.4000,   0.4375,   0.4966,  0.5795,  0.6881,  0.8247,  0.9912,  1.1900,  1.4229,   1.6922,
+    2.0000,   4.2654,   10.1504, 19.2717, 31.2457, 45.6890, 62.2182, 80.4496, 100.0000, 140.0205,
+    170.0000, 100.0000, 78.1682, 59.3955, 43.5434, 30.4733, 20.0465, 12.1244, 6.5683,   3.2397,
+    2.0000,   1.7708,   1.5660,  1.3858,  1.2298,  1.0981,  0.9905,  0.9070,  0.8475,   0.8119,
+    0.8000,   0.8000,   0.8000,  0.8000,  0.8000,  0.8000,  0.8000,  0.8000,  0.8000,   0.8000,
+    0.8000,   0.8029,   0.8112,  0.8243,  0.8416,  0.8625,  0.8864,  0.9127,  0.9408,   0.9701,
+    1.0000};
+
+/**
+ * Map containing the Tropospheric attenuation in dB with 99% probability at 20 GHz in Toulouse
+ * used for tropospheric scintillation losses. From Table 6.6.6.2.1-1 of 3GPP TR 38.811.
+ */
+const std::map<int, float> troposphericScintillationLoss{
+    {10, {1.08}},
+    {20, {0.48}},
+    {30, {0.30}},
+    {40, {0.22}},
+    {50, {0.17}},
+    {60, {0.13}},
+    {70, {0.12}},
+    {80, {0.12}},
+    {90, {0.12}},
+};
+
+/**
+ * @brief Get the base station and user terminal relative distances and heights
+ *
+ * @param a the mobility model of terminal a
+ * @param b the mobility model of terminal b
+ *
+ * @return The tuple [dist2D, dist3D, hBs, hUt], where dist2D and dist3D
+ * are the 2D and 3D distances between a and b, respectively, hBs is the bigger
+ * height and hUt the smallest.
+ */
+std::tuple<double, double, double, double>
+GetBsUtDistancesAndHeights(ns3::Ptr<const ns3::MobilityModel> a,
+                           ns3::Ptr<const ns3::MobilityModel> b)
+{
+    auto aPos = a->GetPosition();
+    auto bPos = b->GetPosition();
+    double distance2D = ns3::ThreeGppChannelConditionModel::Calculate2dDistance(aPos, bPos);
+    double distance3D = ns3::CalculateDistance(aPos, bPos);
+    double hBs = std::max(aPos.z, bPos.z);
+    double hUt = std::min(aPos.z, bPos.z);
+    return std::make_tuple(distance2D, distance3D, hBs, hUt);
+};
+
+/**
+ * @brief Get the base station and user terminal heights for the UmiStreetCanyon scenario
+ *
+ * @param heightA the first height in meters
+ * @param heightB the second height in meters
+ *
+ * @return The tuple [hBs, hUt], where hBs is assumed to be = 10 and hUt other height.
+ */
+std::tuple<double, double>
+GetBsUtHeightsUmiStreetCanyon(double heightA, double heightB)
+{
+    double hBs = (heightA == 10) ? heightA : heightB;
+    double hUt = (heightA == 10) ? heightB : heightA;
+    return std::make_tuple(hBs, hUt);
+};
+
+/**
+ * @brief Computes the free-space path loss using the formula described in 3GPP TR 38.811,
+ * Table 6.6.2
+ *
+ * @param freq the operating frequency
+ * @param dist3d the 3D distance between the communicating nodes
+ *
+ * @return the path loss for NTN scenarios
+ */
+double
+ComputeNtnPathloss(double freq, double dist3d)
+{
+    return 32.45 + 20 * log10(freq / 1e9) + 20 * log10(dist3d);
+};
+
+/**
+ * @brief Computes the atmospheric absorption loss using the formula described in 3GPP TR 38.811,
+ * Sec 6.6.4
+ *
+ * @param freq the operating frequency
+ * @param elevAngle the elevation angle between the communicating nodes
+ *
+ * @return the atmospheric absorption loss for NTN scenarios
+ */
+double
+ComputeAtmosphericAbsorptionLoss(double freq, double elevAngle)
 {
+    double loss = 0;
+    if ((elevAngle < 10 && freq > 1e9) || freq >= 10e9)
+    {
+        int roundedFreq = round(freq / 10e8);
+        loss += atmosphericAbsorption[roundedFreq] / sin(elevAngle * (M_PI / 180));
+    }
 
-NS_LOG_COMPONENT_DEFINE("ThreeGppPropagationLossModel");
+    return loss;
+};
 
-static const double M_C = 3.0e8; //!< propagation velocity in free space
+/**
+ * @brief Computes the ionospheric plus tropospheric scintillation loss using the formulas
+ * described in 3GPP TR 38.811, Sec 6.6.6.1-4 and 6.6.6.2, respectively.
+ *
+ * @param freq the operating frequency
+ * @param elevAngleQuantized the quantized elevation angle between the communicating nodes
+ *
+ * @return the ionospheric plus tropospheric scintillation loss for NTN scenarios
+ */
+double
+ComputeIonosphericPlusTroposphericScintillationLoss(double freq, double elevAngleQuantized)
+{
+    double loss = 0;
+    if (freq < 6e9)
+    {
+        // Ionospheric
+        loss = 6.22 / (pow(freq / 1e9, 1.5));
+    }
+    else
+    {
+        // Tropospheric
+        loss = troposphericScintillationLoss.at(elevAngleQuantized);
+    }
+    return loss;
+};
 
-// ------------------------------------------------------------------------- //
+/**
+ * @brief Computes the clutter loss using the formula
+ * described in 3GPP TR 38.811, Sec 6.6.6.1-4 and 6.6.6.2, respectively.
+ *
+ * @param freq the operating frequency
+ * @param elevAngleQuantized the quantized elevation angle between the communicating nodes
+ * @param sfcl the nested map containing the Shadow Fading and
+ *         Clutter Loss values for the NTN Suburban and Rural scenario
+ *
+ * @return the clutter loss for NTN scenarios
+ */
+double
+ComputeClutterLoss(double freq,
+                   const std::map<int, std::vector<float>>* sfcl,
+                   double elevAngleQuantized)
+{
+    double loss = 0;
+    if (freq < 13.0e9)
+    {
+        loss += (*sfcl).at(elevAngleQuantized)[SFCL_params::S_NLOS_CL]; // Get the Clutter Loss for
+                                                                        // the S Band
+    }
+    else
+    {
+        loss += (*sfcl).at(elevAngleQuantized)[SFCL_params::Ka_NLOS_CL]; // Get the Clutter Loss for
+                                                                         // the Ka Band
+    }
+
+    return loss;
+};
+
+constexpr double M_C = 3.0e8; //!< propagation velocity in free space
+
+} // namespace
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("ThreeGppPropagationLossModel");
 
 NS_OBJECT_ENSURE_REGISTERED(ThreeGppPropagationLossModel);
 
@@ -165,17 +398,8 @@
     NS_ASSERT_MSG(m_channelConditionModel, "First set the channel condition model");
     Ptr<ChannelCondition> cond = m_channelConditionModel->GetChannelCondition(a, b);
 
-    // compute the 2D distance between a and b
-    double distance2d = Calculate2dDistance(a->GetPosition(), b->GetPosition());
-
-    // compute the 3D distance between a and b
-    double distance3d = CalculateDistance(a->GetPosition(), b->GetPosition());
-
-    // compute hUT and hBS
-    std::pair<double, double> heights = GetUtAndBsHeights(a->GetPosition().z, b->GetPosition().z);
-
     double rxPow = txPowerDbm;
-    rxPow -= GetLoss(cond, distance2d, distance3d, heights.first, heights.second);
+    rxPow -= GetLoss(cond, a, b);
 
     if (m_shadowingEnabled)
     {
@@ -183,21 +407,10 @@
     }
 
     // get o2i losses
-    if (cond->GetO2iCondition() == ChannelCondition::O2iConditionValue::O2I &&
-        m_buildingPenLossesEnabled)
-    {
-        if (IsO2iLowPenetrationLoss(cond))
-        {
-            rxPow -= GetO2iLowPenetrationLoss(a, b, cond->GetLosCondition());
-        }
-        else
-        {
-            rxPow -= GetO2iHighPenetrationLoss(a, b, cond->GetLosCondition());
-        }
-    }
-    else if (cond->GetO2iCondition() == ChannelCondition::O2iConditionValue::I2I &&
-             cond->GetLosCondition() == ChannelCondition::LosConditionValue::NLOS &&
-             m_buildingPenLossesEnabled)
+    if (m_buildingPenLossesEnabled &&
+        ((cond->GetO2iCondition() == ChannelCondition::O2iConditionValue::O2I) ||
+         (cond->GetO2iCondition() == ChannelCondition::O2iConditionValue::I2I &&
+          cond->GetLosCondition() == ChannelCondition::LosConditionValue::NLOS)))
     {
         if (IsO2iLowPenetrationLoss(cond))
         {
@@ -214,28 +427,24 @@
 
 double
 ThreeGppPropagationLossModel::GetLoss(Ptr<ChannelCondition> cond,
-                                      double distance2d,
-                                      double distance3d,
-                                      double hUt,
-                                      double hBs) const
+                                      Ptr<MobilityModel> a,
+                                      Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
     double loss = 0;
-    if (cond->GetLosCondition() == ChannelCondition::LosConditionValue::LOS)
-    {
-        loss = GetLossLos(distance2d, distance3d, hUt, hBs);
-    }
-    else if (cond->GetLosCondition() == ChannelCondition::LosConditionValue::NLOSv)
-    {
-        loss = GetLossNlosv(distance2d, distance3d, hUt, hBs);
-    }
-    else if (cond->GetLosCondition() == ChannelCondition::LosConditionValue::NLOS)
-    {
-        loss = GetLossNlos(distance2d, distance3d, hUt, hBs);
-    }
-    else
+    switch (cond->GetLosCondition())
     {
+    case ChannelCondition::LosConditionValue::LOS:
+        loss = GetLossLos(a, b);
+        break;
+    case ChannelCondition::LosConditionValue::NLOSv:
+        loss = GetLossNlosv(a, b);
+        break;
+    case ChannelCondition::LosConditionValue::NLOS:
+        loss = GetLossNlos(a, b);
+        break;
+    default:
         NS_FATAL_ERROR("Unknown channel condition");
     }
 
@@ -402,10 +611,7 @@
 }
 
 double
-ThreeGppPropagationLossModel::GetLossNlosv(double distance2D,
-                                           double distance3D,
-                                           double hUt,
-                                           double hBs) const
+ThreeGppPropagationLossModel::GetLossNlosv(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
     NS_FATAL_ERROR("Unsupported channel condition (NLOSv)");
@@ -469,17 +675,6 @@
     return shadowingValue;
 }
 
-std::pair<double, double>
-ThreeGppPropagationLossModel::GetUtAndBsHeights(double za, double zb) const
-{
-    // The default implementation assumes that the tallest node is the BS and the
-    // smallest is the UT.
-    double hUt = std::min(za, zb);
-    double hBs = std::max(za, zb);
-
-    return std::pair<double, double>(hUt, hBs);
-}
-
 int64_t
 ThreeGppPropagationLossModel::DoAssignStreams(int64_t stream)
 {
@@ -590,15 +785,14 @@
 }
 
 double
-ThreeGppRmaPropagationLossModel::GetLossLos(double distance2D,
-                                            double distance3D,
-                                            double hUt,
-                                            double hBs) const
+ThreeGppRmaPropagationLossModel::GetLossLos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
     NS_ASSERT_MSG(m_frequency <= 30.0e9,
                   "RMa scenario is valid for frequencies between 0.5 and 30 GHz.");
 
+    auto [distance2D, distance3D, hBs, hUt] = GetBsUtDistancesAndHeights(a, b);
+
     // check if hBS and hUT are within the specified validity range
     if (hUt < 1.0 || hUt > 10.0)
     {
@@ -654,15 +848,14 @@
 }
 
 double
-ThreeGppRmaPropagationLossModel::GetLossNlos(double distance2D,
-                                             double distance3D,
-                                             double hUt,
-                                             double hBs) const
+ThreeGppRmaPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
     NS_ASSERT_MSG(m_frequency <= 30.0e9,
                   "RMa scenario is valid for frequencies between 0.5 and 30 GHz.");
 
+    auto [distance2D, distance3D, hBs, hUt] = GetBsUtDistancesAndHeights(a, b);
+
     // check if hBs and hUt are within the validity range
     if (hUt < 1.0 || hUt > 10.0)
     {
@@ -699,7 +892,7 @@
                     (43.42 - 3.1 * log10(hBs)) * (log10(distance3D) - 3.0) +
                     20.0 * log10(m_frequency / 1e9) - (3.2 * pow(log10(11.75 * hUt), 2) - 4.97);
 
-    double loss = std::max(GetLossLos(distance2D, distance3D, hUt, hBs), plNlos);
+    double loss = std::max(GetLossLos(a, b), plNlos);
 
     NS_LOG_DEBUG("Loss " << loss);
 
@@ -850,13 +1043,12 @@
 }
 
 double
-ThreeGppUmaPropagationLossModel::GetLossLos(double distance2D,
-                                            double distance3D,
-                                            double hUt,
-                                            double hBs) const
+ThreeGppUmaPropagationLossModel::GetLossLos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
+    auto [distance2D, distance3D, hBs, hUt] = GetBsUtDistancesAndHeights(a, b);
+
     // check if hBS and hUT are within the validity range
     if (hUt < 1.5 || hUt > 22.5)
     {
@@ -918,14 +1110,13 @@
 }
 
 double
-ThreeGppUmaPropagationLossModel::GetLossNlos(double distance2D,
-                                             double distance3D,
-                                             double hUt,
-                                             double hBs) const
+ThreeGppUmaPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a, Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
-    // check if hBS and hUT are within the vaalidity range
+    auto [distance2D, distance3D, hBs, hUt] = GetBsUtDistancesAndHeights(a, b);
+
+    // check if hBS and hUT are within the validity range
     if (hUt < 1.5 || hUt > 22.5)
     {
         NS_ABORT_MSG_IF(m_enforceRanges, "Uma UT height out of range");
@@ -957,7 +1148,7 @@
     // compute the pathloss
     double plNlos =
         13.54 + 39.08 * log10(distance3D) + 20.0 * log10(m_frequency / 1e9) - 0.6 * (hUt - 1.5);
-    double loss = std::max(GetLossLos(distance2D, distance3D, hUt, hBs), plNlos);
+    double loss = std::max(GetLossLos(a, b), plNlos);
     NS_LOG_DEBUG("Loss " << loss);
 
     return loss;
@@ -1074,13 +1265,15 @@
 }
 
 double
-ThreeGppUmiStreetCanyonPropagationLossModel::GetLossLos(double distance2D,
-                                                        double distance3D,
-                                                        double hUt,
-                                                        double hBs) const
+ThreeGppUmiStreetCanyonPropagationLossModel::GetLossLos(Ptr<MobilityModel> a,
+                                                        Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
+    double distance2D = Calculate2dDistance(a->GetPosition(), b->GetPosition());
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [hBs, hUt] = GetBsUtHeightsUmiStreetCanyon(a->GetPosition().z, b->GetPosition().z);
+
     // check if hBS and hUT are within the validity range
     if (hUt < 1.5 || hUt >= 10.0)
     {
@@ -1135,13 +1328,15 @@
 }
 
 double
-ThreeGppUmiStreetCanyonPropagationLossModel::GetLossNlos(double distance2D,
-                                                         double distance3D,
-                                                         double hUt,
-                                                         double hBs) const
+ThreeGppUmiStreetCanyonPropagationLossModel::GetLossNlos(Ptr<MobilityModel> a,
+                                                         Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
+    double distance2D = Calculate2dDistance(a->GetPosition(), b->GetPosition());
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+    auto [hBs, hUt] = GetBsUtHeightsUmiStreetCanyon(a->GetPosition().z, b->GetPosition().z);
+
     // check if hBS and hUT are within the validity range
     if (hUt < 1.5 || hUt >= 10.0)
     {
@@ -1175,42 +1370,12 @@
     // compute the pathloss
     double plNlos =
         22.4 + 35.3 * log10(distance3D) + 21.3 * log10(m_frequency / 1e9) - 0.3 * (hUt - 1.5);
-    double loss = std::max(GetLossLos(distance2D, distance3D, hUt, hBs), plNlos);
+    double loss = std::max(GetLossLos(a, b), plNlos);
     NS_LOG_DEBUG("Loss " << loss);
 
     return loss;
 }
 
-std::pair<double, double>
-ThreeGppUmiStreetCanyonPropagationLossModel::GetUtAndBsHeights(double za, double zb) const
-{
-    NS_LOG_FUNCTION(this);
-    // TR 38.901 specifies hBS = 10 m and 1.5 <= hUT <= 22.5
-    double hBs;
-    double hUt;
-    if (za == 10.0)
-    {
-        // node A is the BS and node B is the UT
-        hBs = za;
-        hUt = zb;
-    }
-    else if (zb == 10.0)
-    {
-        // node B is the BS and node A is the UT
-        hBs = zb;
-        hUt = za;
-    }
-    else
-    {
-        // We cannot know who is the BS and who is the UT, we assume that the
-        // tallest node is the BS and the smallest is the UT
-        hBs = std::max(za, zb);
-        hUt = std::min(za, zb);
-    }
-
-    return std::pair<double, double>(hUt, hBs);
-}
-
 double
 ThreeGppUmiStreetCanyonPropagationLossModel::GetShadowingStd(
     Ptr<MobilityModel> /* a */,
@@ -1295,13 +1460,13 @@
 }
 
 double
-ThreeGppIndoorOfficePropagationLossModel::GetLossLos(double /* distance2D */,
-                                                     double distance3D,
-                                                     double /* hUt */,
-                                                     double /* hBs */) const
+ThreeGppIndoorOfficePropagationLossModel::GetLossLos(Ptr<MobilityModel> a,
+                                                     Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+
     // check if the distance is outside the validity range
     if (distance3D < 1.0 || distance3D > 150.0)
     {
@@ -1319,13 +1484,13 @@
 }
 
 double
-ThreeGppIndoorOfficePropagationLossModel::GetLossNlos(double distance2D,
-                                                      double distance3D,
-                                                      double hUt,
-                                                      double hBs) const
+ThreeGppIndoorOfficePropagationLossModel::GetLossNlos(Ptr<MobilityModel> a,
+                                                      Ptr<MobilityModel> b) const
 {
     NS_LOG_FUNCTION(this);
 
+    double distance3D = CalculateDistance(a->GetPosition(), b->GetPosition());
+
     // check if the distance is outside the validity range
     if (distance3D < 1.0 || distance3D > 150.0)
     {
@@ -1336,7 +1501,7 @@
 
     // compute the pathloss
     double plNlos = 17.3 + 38.3 * log10(distance3D) + 24.9 * log10(m_frequency / 1e9);
-    double loss = std::max(GetLossLos(distance2D, distance3D, hUt, hBs), plNlos);
+    double loss = std::max(GetLossLos(a, b), plNlos);
 
     NS_LOG_DEBUG("Loss " << loss);
 
